
// Se importan las bibliotecas necesarias
import processing.video.*;
import processing.serial.*;
import cc.arduino.*;
import javax.swing.*;
import java.util.*;


// Se declaran las variables
// PGraphics pg;
PImage img, img0, img1, img2, img3, img4, img5, img6, img1_1, img2_1, img3_1, img4_1, img5_1, img6_1, imgBG, imgBG1, imgBG2, imgBG3, imgBG4, imgBG5, imgBG6, imgBG7, texto1, texto2, texto3, texto4, texto5, texto6, texto7, text, rel, maq, wi, voto, car, plane, pedestal, marco, star, user0, pink; // Imagenes

PFont fuente1, fuente2;

Movie vid1, vid2, vid3, vid4, vid5, vid6, vid; 

int labelX = 1130;
int labelY = 380;

// Campos de entrada del formulario
TextField name;
Textarea data;

// Se define el nombre del archivo donde se guardaran los datos del formulario
String fileName = "formulario.txt";

// Variables que almacenar por separado las líneas del archivo
String firstLine;
String secondLine;

Clock clock; //Declaramos la variable clock de la clase Clock
Timer timerUp; //Declaramos la variable timerUp de la clase Timer

import ddf.minim.* ; // Librería Minim de música de Processing
Minim AudioManager;  // Crea el objeto Minim de audio
Minim minim; 
AudioPlayer son1, son2, son3, son4;  // Se crean los objetos AudioPlayer con las pistas de sonido

//Variables de las clases del programa que cargan las diferentes pantalla
display0 d0 =new display0();
display02 d02 =new display02();
display1 d1 =new display1();
display2 d2 =new display2();
ani1 a1= new ani1();
ani2 a2= new ani2();
ani3 a3= new ani3();
ani4 a4= new ani4();
ani5 a5= new ani5();
ani6 a6= new ani6();
text0 t0=new text0();
text1 t1=new text1();
text2 t2=new text2();
text3 t3=new text3();
text4 t4=new text4();
text5 t5=new text5();
user0 u0=new user0();
user1 u1=new user1();
read0 r0=new read0();

// Variables para definir el texto
String texto, text0, text1, text2, text3, text4, text5, text6 ;

//Valores que recibe de Arduino
int valor;   


Serial myPort, serialPort; // Se declara el puerto desde el que se leerán los datos de Arduino

request_t       request;
requestStatus_t reqStatus = requestStatus_t.IDLE;

// Variables de gestión de las entradas desde el puerto 
byte[]   ackBuff = new byte[G_DEF.ACK_BUF_LEN];
byte[][] pix     = new byte[G_DEF.F_H][G_DEF.MAX_ROW_LEN];

double waitTimeout    = 0;
double fpsTimeStamp   = 0;

PFont  myFont;
PImage currFrame;

boolean bSerialDebug = true;

int currRow = 0;
byte thresh  = (byte)130;

PVector lastCenter = new PVector(0, 0);
float tmp_x0 = 0, tmp_y0 = 0, tmp_x1 = 0, tmp_y1 = 0;
float x0 = 0, y0 = 0, x1 = 0, y1 = 0;

boolean bKalmanEnabled = true;
simpleKalman filter_x0 = new simpleKalman();
simpleKalman filter_y0 = new simpleKalman();
simpleKalman filter_x1 = new simpleKalman();
simpleKalman filter_y1 = new simpleKalman();



void setup() {

  size(1920, 1080); // Tamaño de la pantalla
  background(245, 238, 248); //Color del fondo  

  vid1 = new Movie(this, "vid1.mp4");
  vid2 = new Movie(this, "vid2.mp4");
  vid3 = new Movie(this, "vid3.mp4");
  vid4 = new Movie(this, "vid4.mp4");
  vid5 = new Movie(this, "vid5.mp4");
  vid6 = new Movie(this, "vid6.mp4");

  pink= loadImage("img/pink.png");


  clock = new Clock(); //Se declara la variable de la clase Clock
  timerUp = new Timer(0, 100000000); //Contador ascendente de la clase Timer

  // Se inicializan los campos de entrada del formulario
  name = new TextField(1130, 370, 500, 40);
  data = new Textarea(1130, 500, 500, 300);

  fuente1 = createFont("data/CooperFiveOpti-Black.otf", 14);
  fuente2 = createFont("data/6600-fontps.ttf", 14);

  // Se inicializan las variables del sonido
  minim = new Minim(this);          //  Se define la variable Minim

  son1 = minim.loadFile("sound/son1.mp3");      // Se carga el fichero con la música de fondo
  son1.loop();                               //  La música de fondo se reproducira en bucle

  // Se inicializan las variables de las diferentes clases que cargan las pantallas
  d0.init();
  d02.init();  
  d1.init();
  d2.init();
  a1.init();
  a2.init();
  a3.init();
  a4.init();
  a5.init();
  a6.init();
  t0.init();
  t1.init();
  t2.init();
  t3.init();
  t4.init();
  t5.init();
  u0.init();
  u1.init();
  r0.init(); 

  // Conexión con Processing
  printArray(Serial.list()); // Se imprimen por consola el listado de puertos serie

  frameRate(30);

  // Variable para el dibujo de los fotogramas
  currFrame = createImage(G_DEF.F_W, G_DEF.F_H, RGB);

  // Se crea una fuente con el tamaño ajustable a la ventana
  myFont = createFont("Arial", G_DEF.FONT_SIZE);
  textFont(myFont);

  // Lista todos los puertos disponibles en el sistema
  printArray(Serial.list());

  // Se inicializa el puerto serie y su configuración
  delay(500);
  serialPort = new Serial(this, "COM5", G_DEF.BAUDRATE); // Se carga el puerto desde el que se obtendrán los datos de Arduino
  serialPort.bufferUntil(G_DEF.LF); //Indica en el setup() que se llenará el buffer hasta que se encuentre con un salto de línea
  serialPort.clear();
  delay(2000);
  reqStatus = reqStatus.IDLE;
  request = request.STREAM0PPB;
}

void movieEvent(Movie m) {
  m.read();
}

void draw() {

  if (valor=='v') {
    tint(255, 255);
  } else {
    tint(255, 0);
  }

  // Función para el dibujo del vídeo
  drawVideo();

  // Función para obtener el valor recibido por el puerto serie
  getValor();

  switch(valor) {  

    // Caso 0 pantalla de inicio
    case('4'):      // Caso 0 pantalla de inicio
    noTint();
    vid1.stop();
    vid2.stop();
    vid3.stop();
    vid4.stop();
    vid5.stop();
    vid6.stop();  

    background(245, 238, 248);    // Color de fondo
    if (timerUp.getTimeSec()< 5.5) { //Si la variable con los segundos transcurridos desde la última ejecución es menor que 5,5:   
      // timerUp.reset(); //Se resetea el contador para ponerlo a cero, si no seguimos este paso el contador seguirá donde se quedó la última vez
      d0.update(); // Pasamos a la página "Menú"

      clock.update(); //De manera continuada se ejecuta la función update() para que se calcule el tiempo que ha pasado
      timerUp.update(clock.getDeltaMillis()); //Recupera el tiempo que ha pasado
      timerUp.start (true); //Si es true se pone en marcha el contador ascendente

      println("Segundos que pasan: "+timerUp.getTimeSec()); //Para comprobar que el programa se ejecuta correctamente imprimimos por consola los segundos que pasan
      println("Valor: "+valor); //Para comprobar que el programa se ejecuta correctamente imprimimos por consola el mode en el que nos encontramos
    } else {

      d02.update(); //Pasamos a la página "Menú"
    }
    break;

  case '5':    // Caso 1 pantalla con el texto de Milena Mavic, se cargan las clases del fondo, la imagen y el texto
    noTint();
    vid1.play();
    vid2.stop();
    vid3.stop();
    vid4.stop();
    vid5.stop();
    vid6.stop(); 

    noTint();
    vid=vid1;  // Se definen las variables de las imagen de la pionera, el texto y el fondo
    imgBG=imgBG1;
    text=texto1;

    d1.update(imgBG);       // Se cargan las clases de la primera pantalla y el texto

    t0.update(text); 

    break;

  case '6':     // Caso 2 pantalla con el texto de María Luz Morales, se cargan las clases del fondo, la imagen y el texto
    noTint();
    vid1.stop();
    vid2.play();
    vid3.stop();
    vid4.stop();
    vid5.stop();
    vid6.stop();  

    vid=vid2;   // Se definen las variables de las imagen de la pionera, el texto y el fondo
    imgBG=imgBG2;
    text=texto2;
    d1.update(imgBG);             // Se carga la clase de la primera pantalla y el texto
    t1.update(text);  

    break;

  case '7':     // Caso 3 pantalla con el texto de Hedy Lammar, se cargan las clases del fondo, la imagen y el texto
    noTint();
    vid1.stop();
    vid2.stop();
    vid3.play();
    vid4.stop();
    vid5.stop();
    vid6.stop();

    vid=vid3;   // Se definen las variables de las imagen de la pionera, el texto y el fondo
    imgBG=imgBG3;
    text=texto3;
    d1.update(imgBG);            // Se carga la clase de la primera pantalla y el texto
    t2.update(text);  

    break;

  case '3':     // Caso 4 pantalla con el texto de Bertha Benz, se cargan las clases del fondo, la imagen y el texto
    noTint();
    vid1.stop();
    vid2.stop();
    vid3.stop();
    vid4.play();
    vid5.stop();
    vid6.stop();    

    vid=vid4;   // Se definen las variables de las imagen de la pionera, el texto y el fondo
    imgBG=imgBG4; 
    text=texto4;
    d1.update(imgBG);             // Se carga la clase de la primera pantalla y el texto
    t3.update(text);  

    break;   

  case '9':     // Caso 5 pantalla con el texto de Clara Campoamor, se cargan las clases del fondo, la imagen y el texto
    noTint();

    vid1.stop();
    vid2.stop();
    vid3.stop();
    vid4.stop();
    vid5.play();
    vid6.stop();

    vid=vid5;   // Se definen las variables de las imagen de la pionera, el texto y el fondo
    imgBG=imgBG5; 
    text=texto5;
    d1.update(imgBG);            // Se carga la clase de la primera pantalla y el texto
    t4.update(text);  

    break;   

  case '2':     // Caso 6 pantalla con el texto de Amelia Earhart, se cargan las clases del fondo, la imagen y el texto
    noTint();

    vid1.stop();
    vid2.stop();
    vid3.stop();
    vid4.stop();
    vid5.stop();
    vid6.play(); 

    vid=vid6;   // Se definen las variables de las imagen de la pionera, el texto y el fondo
    imgBG=imgBG6;
    text=texto6;
    d1.update(imgBG);            // Se carga la clase de la primera pantalla y el texto
    t5.update(text);  

    break;

  case 'q':     // Caso 1.1 pantalla con la animación de Milena Mavic
    image(pink, 0, 0);
    tint(133, 193, 233, 220);  // Se define la variable de la imagen de la pionera y la tintura de la misma
    img=img1;
    d2.update(img);           // Se carga la clase de la segunda pantalla
    a1.update();              // Se carga la animación

    break; 

  case 'w' :      // Caso 2.1 pantalla con la animación de María Luz Morales
    image(pink, 0, 0);
    tint(252, 243, 207, 220);  // Se define la variable de la imagen de la pionera y la tintura de la misma
    img=img2;
    d2.update(img);            // Se carga la clase de la segunda pantalla
    a2.update();              // Se carga la animación

    break; 

  case 'e' :      // Caso 3.1 pantalla con la animación de Hedy Lammar
    image(pink, 0, 0);
    tint(245, 203, 167, 220);  // Se define la variable de la imagen de la pionera y la tintura de la misma
    img=img3; 
    d2.update(img);            // Se carga la clase de la segunda pantalla
    a3.update();              // Se carga la animación

    break; 

  case 'r' :      // Caso 4.1 pantalla con la animación de Bertha Benz
    image(pink, 0, 0);
    tint(241, 198, 138);  // Se define la variable de la imagen de la pionera y la tintura de la misma
    img=img4; 
    d2.update(img);            // Se carga la clase de la segunda pantalla
    a4.update();              // Se carga la animación

    break; 

  case 't' : // Caso 5.1 pantalla con la animación de Clara Campoamor
    image(pink, 0, 0);
    tint(213, 245, 227, 220);  // Se define la variable de la imagen de la pionera y la tintura de la misma
    img=img5; 
    d2.update(img);            // Se carga la clase de la segunda pantalla
    a5.update();              // Se carga la animación

    break; 

  case 'y' :    // Caso 6.1 pantalla con la animación de Amelia Earhart
    image(pink, 0, 0);
    tint(250, 219, 216, 220);  // Se define la variable de la imagen de la pionera y la tintura de la misma
    img=img6; 
    d2.update(img);            // Se carga la clase de la segunda pantalla
    a6.update();              // Se carga la animación

    break;

  case 'c':     // Caso 7 pantalla para entrar los datos del usuario en el formulario
    noTint();
    background(245, 238, 248); //Color del fondo   
    vid1.stop();
    vid2.stop();
    vid3.stop();
    vid4.stop();
    vid5.stop();
    vid6.stop(); 
    //   video.stop();

    img=user0;   // Se definen las variables de las imagen de la pionera, el texto y el fondo
    imgBG=imgBG7;
    text=texto7;

    u0.update(imgBG);            // Se carga la clase de la pantalla con el formulario

    break;

  case 'v':     // Caso 8 pantalla para visualizar los datos y el video del usuario
    noTint();
    tint(255, 255);
    // Dibujo del vídeo de los visitantes
    drawVideo();

    // Marcos del video y del texto
    image(marco, 95, 165, 753, 753);
    image(texto7, 930, 90, 900, 900);

    // Se carga el texto del archivo cumplimentado en la pantalla anterior
    String[] contentFile = loadStrings(fileName);

    // Si el archivo no esta vacío
    if (contentFile != null && contentFile.length > 0) {
      // Obtiene la primera línea del archivo
      if (contentFile.length >= 1) {
        firstLine = contentFile[0];
      }

      // Obtiene la segunda línea del archivo
      if (contentFile.length >= 2) {
        secondLine= contentFile[1];
      }
    }

    fill(112, 123, 124);

    if (firstLine != null) {
      textFont(fuente2);
      textSize(40);

      text(firstLine, labelX-85, labelY-160, 690, 200);
    }

    if (secondLine != null) {
      textFont(fuente1);    
      textSize(40);

      text(secondLine, labelX-85, labelY, 690, 500);
    }

    break;
  }
}

// Se definen las acciones que se realizaran desde el teclado
void keyPressed() {
  switch (key) {

  case 'z':  
    int i = request.ordinal()+1;
    if (i >= request_t.values().length) i=0;
    request = request_t.values()[i];
    serialPort.clear();
    reqStatus = requestStatus_t.IDLE;

    break; 
  case 'k':  
    bKalmanEnabled = !bKalmanEnabled;
    break; 
  case '+':  
    thresh++;
    break; 
  case '-':  
    thresh--;
    break; 
  case 's':  
    saveFrame(); 
    break; 
  default: 
    break;
  }

  // Se registra la entrada de texto en los campos
  if (keyCode == UP) {
    name.clicked = true;
    data.clicked = false;
    name.highlight();
    data.unhighlight();
  } else if (keyCode == DOWN) {
    name.clicked = false;
    data.clicked = true;
    name.unhighlight();
    data.highlight();
  } else {
    if (keyCode != BACKSPACE && key != 'c' && key != 'v' && key != '2' && key != '3' && key != '4' && key != '5' && key != '6' && key != '7' && key != '8' && key != '9' && key != 'q' && key != 'w' && key != 'e' && key != 'r' && key != 't' && key != 'y'  && key != '0' && key != '1' && keyCode != UP && keyCode != DOWN) {
      formu();
      name.type();
      data.type();

      // Se guardan los datos en el archivo al presionar Enter
      if (keyCode == ENTER) {
        saveData();
        reset();
        formu();
        valor='1';
      }
    }
  }
}
