//Se cargan las bibliotecas necesarias en el programa

#if 1
__asm volatile("nop");
#endif

#include <LCD_I2C.h>
#include <LiquidCrystal_I2C.h>

#include <Wire.h>

#include "IO_config.h"
#include "sensor.h"
#include "fifo.h"

LiquidCrystal_I2C lcd(0x27, 16, 2);  // Se crea el objeto lcd con la dirección 0x27, 16 columnas y 2 filas

// A continuación se declaran las variables para el funcionamiento de la cámara

static const byte LF = 10;  // Carácter de avance de línea
#ifdef USE_SOFT_SERIAL
#include <SoftwareSerial.h>
static const unsigned int _BAUDRATE = 38400;  // Tasa de baudios  máxima para procesadores de 8 MHz
#define txPin A0
#define rxPin A1
SoftwareSerial mySerial = SoftwareSerial(rxPin, txPin);
SoftwareSerial *serialPtr = &mySerial;
#else
static const unsigned long _BAUDRATE = 500000;
HardwareSerial *serialPtr = &Serial;
#endif

uint8_t rcvbuf[16], rcvbufpos = 0, c;

// Cálculo de FPS
static unsigned int oneSecond = 1000;
unsigned int volatile frameCount = 0;
unsigned int fps = 0;
unsigned long volatile lastTime = 0;
unsigned long volatile timeStamp = 0;

//Etiquetas para la resolución de vídeo
#define QQQVGA
// Quarter Quarter VGA
#ifdef QQVGA
static const uint8_t fW = 160;
static const uint8_t fH = 120;
static const frameFormat_t frameFormat = FF_QQVGA;
#else
//Quarter Quarter Quarter VGA
#ifdef QQQVGA
static const uint8_t fW = 80;
static const uint8_t fH = 60;
static const frameFormat_t frameFormat = FF_QQQVGA;
#endif
#endif

//Constantes y variables relacionadas con el procesamiento de imágenes
static const uint8_t TRACK_BORDER = 4;  // Múltiplos de dos (YUYV: 2 pixels)
static const uint8_t YUYV_BPP = 2;      // bytes por pixel
static const unsigned int MAX_FRAME_LEN = fW * YUYV_BPP;
byte rowBuf[MAX_FRAME_LEN];
unsigned int volatile nRowsSent = 0;
boolean volatile bRequestPending = false;
boolean volatile bNewFrame = false;
uint8_t volatile thresh = 128;

enum serialRequest_t {
  SEND_NONE = 0,
  SEND_DARK,
  SEND_BRIG,
  SEND_FPS,
  SEND_0PPB = MAX_FRAME_LEN,
  SEND_1PPB = fW,
  SEND_2PPB = fW / 2,
  SEND_4PPB = fW / 4,
  SEND_8PPB = fW / 8
};

//Se inicializa la máxima definicion de imagenes
serialRequest_t serialRequest = SEND_0PPB;


// Se declaran las variables del  resto del programa

int trig = 14;       // Pin del sensor de ultrasonidos
int echo = 5;       // Pin del sensor de distancia
int time, distance;  // Cálculo de la distancia
char dato, valor;

// Variables sonido sirena
// int duration = 250;  //Duración del sonido buzzer
// int frecMin = 2000;  //Frecuencia minima
// int frecMax = 4000;  //Frecuencia maxima
// int i = 0;           // Auxiliar efecto sirena

// Variables de los switchs
int SwitchState = 0;

int SwitchState1 = 0;
int SwitchState2 = 0;
int SwitchState3 = 0;
int SwitchState4 = 0;
int SwitchState5 = 0;
int SwitchState6 = 0;
int SwitchState0 = 0;
int SwitchState7 = 0;

int SwitchState1_1 = 0;
int SwitchState2_1 = 0;
int SwitchState3_1 = 0;
int SwitchState4_1 = 0;
int SwitchState5_1 = 0;
int SwitchState6_1 = 0;

const unsigned long tiempoMuestreo = 500;  // Intervalo de tiempo entre cada muestreo (en milisegundos)
unsigned long tiempoAnterior = 0;          // Almacena el tiempo del último muestreo

void setup() {
  // Se define el texto de la pantalla LCD
  lcd.init();                // Inicializar pantalla
  lcd.backlight();           // Encender luz de fondo
  lcd.setCursor(0, 0);       // Posicion del cursor principio de la primera línea
  lcd.print(F("PRIMERAS"));  // Texto de la primera linea


  pinMode(50, INPUT_PULLUP);  // Pin 50 entrada pulsador 1
  pinMode(48, INPUT_PULLUP);  // Pin 48 entrada pulsador 2
  pinMode(46, INPUT_PULLUP);  // Pin 46 entrada pulsador 3
  pinMode(44, INPUT_PULLUP);  // Pin 44 entrada pulsador 4
  pinMode(42, INPUT_PULLUP);  // Pin 42 entrada pulsador 5
  pinMode(40, INPUT_PULLUP);  // Pin 40 entrada para el pulsador 6

  pinMode(51, INPUT_PULLUP);  // Pin 51 entrada pulsador 1.1
  pinMode(49, INPUT_PULLUP);  // Pin 49 entrada pulsador 2.1
  pinMode(47, INPUT_PULLUP);  // Pin 47 entrada pulsador 3.1
  pinMode(45, INPUT_PULLUP);  // Pin 45 entrada pulsador 4.1
  pinMode(43, INPUT_PULLUP);  // Pin 43 entrada pulsador 5.1
  pinMode(41, INPUT_PULLUP);  // Pin 41 entrada pulsador 6.1
  pinMode(52, INPUT_PULLUP);  // Pin 52 entrada pulsador 0
  pinMode(53, INPUT_PULLUP);  // Pin 53 entrada pulsador 1

  pinMode(trig, OUTPUT);  // Pin 14 salida sensor de ultrasonidos
  pinMode(echo, INPUT);   // Pin 5 entrada sensor de ultrasonidos

  pinMode(31, OUTPUT);  // Pin salida led verde
  pinMode(33, OUTPUT);  // Pin salida led amarillo
  pinMode(35, OUTPUT);  // Pin salida led rojo

  setup_IO_ports();

  serialPtr->begin(_BAUDRATE);  // Se abre el puerto serie con velocidad de transmisión 115200

  serialPtr->println("Initializing sensor...");  //Se inicaliza el sensor de la cámara
  for (int i = 0; i < 10; i++) {
    unsigned int result = sensor_init(frameFormat);
    if (result != 0) {
      serialPtr->print("Iniciado OK, sensor PID: ");
      serialPtr->println(result, HEX);
      break;
    } else if (i == 5) {
      serialPtr->println("Iniciado OK, sensor PID");
      while (1)
        ;

    } else {
      serialPtr->println("conectando...");
      delay(300);
    }
  }
  attachInterrupt(VSYNC_INT, (void (*)()) & vsyncIntFunc, FALLING);
  delay(100);
}
void loop() {

  // Funciones calculo de la distancia con el sensor de ultrasonidos
  digitalWrite(trig, LOW);     // Trigger apagado
  delayMicroseconds(4);        // Retardo del pin
  digitalWrite(trig, HIGH);    // Trigger encendido
  delayMicroseconds(10);       // Retardo del pin
  digitalWrite(trig, LOW);     // Trigger apagado
  time = pulseIn(echo, HIGH);  // Señal de sonido emitida por el trigger

  distance = (time / 2) / 29;  // Cálculo de la distancia
  unsigned long tiempoActual = millis();

  // Mediante estos if se enviará un valor determinado a Processing y se encenderán o apagarán los leds

  if (distance > 5 && distance <= 10) {

    digitalWrite(31, 1);  // Distancia entre 5 y 10 cm led verde encendido los demas apagados
    digitalWrite(33, 0);
    digitalWrite(35, 0);
    lcd.init();
    lcd.setCursor(0, 0);          // Posicion del cursor al principio de la primera línea
    lcd.print(F("Elige"));        // Texto de la primera linea
    lcd.setCursor(0, 1);          // Posicion del cursor al principio de la segunda línea
    lcd.print(F("una primera"));  // Texto de la segunda linea    
    
    // Valor que se envía a Processing
    valor = '4';

    delay(100);  // Retardo para dar tiempo a gestionar los datos
  }
  if (distance > 10 && distance <= 20) {

    digitalWrite(31, 0);
    digitalWrite(33, 1);  // Distancia >10 y <= 20 se enciende el led amarillo los demas se apagan
    digitalWrite(35, 0);
    lcd.init();
    lcd.setCursor(0, 0);       // Posicion del cursor al principio de la primera línea
    lcd.print(F("Acercate"));  // Texto de la primera linea
    lcd.setCursor(0, 1);       // Posicion del cursor al principio de la segunda línea
    lcd.print(F("mas"));       // Texto de la segunda linea

    delay(100);  // Retardo para dar tiempo para a la gestion de los datos
  }

  if (distance > 20 && distance <= 25) {

    digitalWrite(31, 0);
    digitalWrite(33, 0);
    digitalWrite(35, 1);  // Distancia >20 y <= 25 el led rojo se enciende los demas se apagan
    lcd.init();
    lcd.setCursor(0, 0);       // Posicion del cursor al principio de la primera línea
    lcd.print(F("Acercate"));  // Texto de la primera linea

    delay(100);

    // Cuando se alcanza este valor sonara una sirena
    /*   for (i = frecMin; i <= frecMax; i++) {  //Sonido  agudo
      tone(A2, i, duration);
    }

    for (i = frecMax; i >= frecMin; i--) {  // //Sonido grave
      tone(A2, i, duration);
    }
   */
  }

  if (distance > 25) {
    // Distancia >25 todos los leds apagados
    digitalWrite(31, 0);
    digitalWrite(33, 0);
    digitalWrite(35, 0);

    delay(100);  // Retardo para dar tiempo a la gestion de los datos
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState1 = digitalRead(50);

  // Pulsador presionado (LOW)
  if (SwitchState1 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);     // Posicion del cursor al principio de la primera línea
    lcd.print(F("MILENA"));  // Texto de la primera linea
    lcd.setCursor(0, 1);     // Posicion del cursor al principio de la segunda línea
    lcd.print(F("MAVIC"));   // Texto de la segunda linea

    valor = '5';  // Valor que se envía a Processing
    delay(100);
  }
  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState2 = digitalRead(48);

  // Pulsador presionado (LOW)
  if (SwitchState2 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);        // Posicion del cursor al principio de la primera línea
    lcd.print(F("MARIA LUZ"));  // Texto de la primera linea
    lcd.setCursor(0, 1);        // Posicion del cursor al principio de la segunda línea
    lcd.print(F("MORALES"));    // Texto de la segunda linea

    valor = '6';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState3 = digitalRead(46);

  // Si el pulsador está presionado (LOW)
  if (SwitchState3 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);     // Posicion del cursor al principio de la primera línea
    lcd.print(F("HEDDY"));   // Texto de la primera linea
    lcd.setCursor(0, 1);     // Posicion del cursor al principio de la segunda línea
    lcd.print(F("LAMARR"));  // Texto de la segunda linea

    valor = '7';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState4 = digitalRead(44);

  // Pulsador presionado (LOW)
  if (SwitchState4 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);     // Posicion del cursor al principio de la primera línea
    lcd.print(F("BERTHA"));  // Texto de la primera linea
    lcd.setCursor(0, 1);     // Posicion del cursor al principio de la segunda línea
    lcd.print(F("BENZ"));    // Texto de la segunda linea

    valor = '3';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState5 = digitalRead(42);

  // Pulsador presionado (LOW)
  if (SwitchState5 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);        // Posicion del cursor al principio de la primera línea
    lcd.print(F("CLARA"));      // Texto de la primera linea
    lcd.setCursor(0, 1);        // Posicion del cursor al principio de la segunda línea
    lcd.print(F("CAMPOAMOR"));  // Texto de la segunda linea

    valor = '9';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState6 = digitalRead(40);

  // Pulsador presionado (LOW)
  if (SwitchState6 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);      // Posicion del cursor al principio de la primera línea
    lcd.print(F("AMELIA"));   // Texto de la primera linea
    lcd.setCursor(0, 1);      // Posicion del cursor al principio de la segunda línea
    lcd.print(F("EARHART"));  // Texto de la segunda linea

    valor = '2';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState1_1 = digitalRead(51);

  // Pulsador presionado (LOW)
  if (SwitchState1_1 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);     // Posicion del cursor al principio de la primera línea
    lcd.print(F("MILENA"));  // Texto de la primera linea
    lcd.setCursor(0, 1);     // Posicion del cursor al principio de la segunda línea
    lcd.print(F("MAVIC"));   // Texto de la segunda linea

    valor = 'q';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState2_1 = digitalRead(49);

  // Pulsador presionado (LOW)
  if (SwitchState2_1 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);        // Posicion del cursor al principio de la primera línea
    lcd.print(F("MARIA LUZ"));  // Texto de la primera linea
    lcd.setCursor(0, 1);        // Posicion del cursor al principio de la segunda línea
    lcd.print(F("MORALES"));    // Texto de la segunda linea

    valor = 'w';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState3_1 = digitalRead(47);

  // Pulsador presionado (LOW)
  if (SwitchState3_1 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);     // Posicion del cursor al principio de la primera línea
    lcd.print(F("HEDDY"));   // Texto de la primera linea
    lcd.setCursor(0, 1);     // Posicion del cursor al principio de la segunda línea
    lcd.print(F("LAMARR"));  // Texto de la segunda linea

    valor = 'e';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState4_1 = digitalRead(45);

  // Pulsador presionado (LOW)
  if (SwitchState4_1 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);     // Posicion del cursor al principio de la primera línea
    lcd.print(F("BERTHA"));  // Texto de la primera linea
    lcd.setCursor(0, 1);     // Posicion del cursor al principio de la segunda línea
    lcd.print(F("BENZ"));    // Texto de la segunda linea

    valor = 'r';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState5_1 = digitalRead(43);

  // Pulsador presionado (LOW)
  if (SwitchState5_1 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);        // Posicion del cursor al principio de la primera línea
    lcd.print(F("CLARA"));      // Texto de la primera linea
    lcd.setCursor(0, 1);        // Posicion del cursor al principio de la segunda línea
    lcd.print(F("CAMPOAMOR"));  // Texto de la segunda linea

    valor = 't';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState6_1 = digitalRead(41);

  // Pulsador presionado (LOW)
  if (SwitchState6_1 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);      // Posicion del cursor al principio de la primera línea
    lcd.print(F("AMELIA"));   // Texto de la primera linea
    lcd.setCursor(0, 1);      // Posicion del cursor al principio de la segunda línea
    lcd.print(F("EARHART"));  // Texto de la segunda linea

    valor = 'y';  // Valor que se envía a Processing
    delay(100);
  }

  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState0 = digitalRead(52);

  // Pulsador presionado (LOW)
  if (SwitchState0 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);        // Posicion del cursor al principio de la primera línea
    lcd.print(F("Ingresa"));    // Texto de la primera linea
    lcd.setCursor(0, 1);        // Posicion del cursor al principio de la segunda línea
    lcd.print(F("tus datos"));  // Texto de la segunda linea

    valor = 'c';  // Valor que se envía a Processing
    delay(100);
  }
  // Se lee el valor del pulsador digitalRead() que comprueba si hay tensión o no en el pin
  SwitchState7 = digitalRead(53);

  // Pulsador presionado (LOW)
  if (SwitchState7 == LOW) {

    lcd.init();
    lcd.setCursor(0, 0);           // Posicion del cursor al principio de la primera línea
    lcd.print(F("Ya eres"));       // Texto de la primera linea
    lcd.setCursor(0, 1);           // Posicion del cursor al principio de la segunda línea
    lcd.print(F("una primera!"));  // Texto de la segunda linea

    valor = 'v';  // Valor que se envía a Processing

    delay(10);
  }

  serialPtr->write(valor);  // Se imprime la variable valor en el puerto serie el valor dato que se enviará a Processing
}

// Controlador de interrupciones VSYNC para la señal de sincronización vertical (VSYNC) del sistema.
// Comprueba las solicitudes pendientes
void __inline__ vsyncIntFunc() {
  DISABLE_WREN;  // Se deshabilita la escritura en FIFO

  if (bRequestPending && bNewFrame) {
    detachInterrupt(VSYNC_INT);
    processRequest();
    bRequestPending = false;
    bNewFrame = false;
    attachInterrupt(VSYNC_INT, (void (*)()) & vsyncIntFunc, FALLING);
  } else {
    ENABLE_WRST;
    SET_RCLK_H;
    SET_RCLK_L;
    DISABLE_WRST;
    _delay_cycles(10);

    ENABLE_WREN;  // Se habilita la escritura en FIFO
    bNewFrame = true;
  }
}

//Solicitud de proceso de puerto serie. Procesa la solicitud recibida a través del puerto serie y realiza diferentes acciones dependiendo del valor de serialRequest
// En este caso se emplea el caso SEND_0PPB, el de mayor definición de imagen
void processRequest() {

  fifo_rrst();

  switch (serialRequest) {
    case SEND_0PPB:
      for (int i = 0; i < fH; i++) {
        fifo_readRow0ppb(rowBuf, rowBuf + serialRequest);
        serialPtr->write(rowBuf, serialRequest);
        serialPtr->write(LF);
      }
      break;
    case SEND_1PPB:
      for (int i = 0; i < fH; i++) {
        fifo_readRow1ppb(rowBuf, rowBuf + serialRequest);
        serialPtr->write(rowBuf, serialRequest);
        serialPtr->write(LF);
      }
      break;
    case SEND_2PPB:
      for (int i = 0; i < fH; i++) {
        fifo_readRow2ppb(rowBuf, rowBuf + serialRequest);
        serialPtr->write(rowBuf, serialRequest);
        serialPtr->write(LF);
      }
      break;
    case SEND_4PPB:
      for (int i = 0; i < fH; i++) {
        fifo_readRow4ppb(rowBuf, rowBuf + serialRequest);
        serialPtr->write(rowBuf, serialRequest);
        serialPtr->write(LF);
      }
      break;
    case SEND_8PPB:
      for (int i = 0; i < fH; i++) {
        fifo_readRow8ppb(rowBuf, rowBuf + serialRequest, thresh);
        serialPtr->write(rowBuf, serialRequest);
        serialPtr->write(LF);
      }
      break;
    case SEND_BRIG:
      fifo_getBrig(rowBuf, fW, fH, TRACK_BORDER, thresh);
      serialPtr->write(rowBuf, 4);
      serialPtr->write(LF);
      break;
    case SEND_DARK:
      fifo_getDark(rowBuf, fW, fH, TRACK_BORDER, thresh);
      serialPtr->write(rowBuf, 4);
      serialPtr->write(LF);
      break;
    case SEND_FPS:
      calcFPS(fps);
      serialPtr->print(fps, DEC);
      serialPtr->write(LF);
      break;

    default: break;
  }
}

// Se obtiene la frecuencia de fotogramas por segundo (FPS) actual y la almacena en la variable currentFPS
void calcFPS(unsigned int &currentFPS) {
  unsigned long currTime = millis();
  unsigned long currTimeDiff = currTime - lastTime;
  if (currTimeDiff >= oneSecond) {
    lastTime = currTime;
    currentFPS = (oneSecond * frameCount) / currTimeDiff;
    frameCount = 0;
  }
  while (GET_VSYNC)
    ;  // Se espera a que termine un fotograma antiguo
  while (!GET_VSYNC)
    ;  // Se espera a que comience un nuevo fotograma
  frameCount++;
}


//Evento de puerto serie. Se ejecuta automáticamente cuando hay datos disponibles en el puerto serie
//lee el siguiente byte disponible del puerto serie utilizando la función read() y lo almacena en la variable c
//Asigna el 0 como final de la cadena y llama a la función  parseSerialBuffer() para procesar la cadena recibida
void serialEvent() {
  while (serialPtr->available()) {
    // Se obtiene el nuevo byte
    c = serialPtr->read();
    if (c != LF) {
      rcvbuf[rcvbufpos++] = c;
    } else if (c == LF) {
      rcvbuf[rcvbufpos++] = 0;
      rcvbufpos = 0;
      parseSerialBuffer();
    }
  }
}

//Análisis del búfer del puerto serie. analiza la cadena recibida y toma decisiones en función de su contenido.
//Puede responder a comandos específicos y realizar acciones en consecuencia, como establecer valores de variables
//o enviar respuestas a través del puerto serie.
void parseSerialBuffer(void) {
  if (strcmp((char *)rcvbuf, "hello") == 0) {
    serialPtr->print("Hello to you too!\n");
  } else if (strlen((char *)rcvbuf) > 5 && strncmp((char *)rcvbuf, "send ", 5) == 0) {
    serialRequest = (serialRequest_t)atoi((char *)(rcvbuf + 5));
    serialPtr->print("ACK\n");
    bRequestPending = true;
  } else if (strlen((char *)rcvbuf) > 5 && strncmp((char *)rcvbuf, "dark ", 5) == 0) {
    thresh = atoi((char *)(rcvbuf + 5));
    serialPtr->print("ACK\n");
    serialRequest = SEND_DARK;
    bRequestPending = true;
  } else if (strlen((char *)rcvbuf) > 5 && strncmp((char *)rcvbuf, "brig ", 5) == 0) {
    thresh = atoi((char *)(rcvbuf + 5));
    serialPtr->print("ACK\n");
    serialRequest = SEND_BRIG;
    bRequestPending = true;
  } else if (strlen((char *)rcvbuf) > 7 && strncmp((char *)rcvbuf, "thresh ", 7) == 0) {
    thresh = atoi((char *)(rcvbuf + 7));
  }
  /*else if (strlen((char *)rcvbuf) == 1) {
    // If only one character is received, print it as is.
    serialPtr->print((char)rcvbuf[0]);
    serialPtr->print("\n");
}*/
}
