class Timer { //Clase auxiliar con las funcionalidades del contador

  boolean up; //Variable que nos indica si tendremos que sumar o restar el tiempo que ha pasado cuando actualizamos el valor
  int startPoint; //Tiempo inicial
  int endPoint; //Tiempo final que queremos contar
  boolean counting; //Variable que guarda  si el cronómetro está actualmente en marcha o parado
  int currentTime; //Variable que guarda el tiempo actual del cronómetro

  Timer() {
    up = true;
    startPoint = 0;
    endPoint = 0;
    counting = false;
    currentTime = startPoint;
  }

  Timer (int sPoint, int ePoint) {
    startPoint = sPoint;
    endPoint = ePoint;

    if (startPoint <= endPoint) {
      up = true;
    } else {
      up = false;
    }

    currentTime = startPoint;
  }

  void reset () { //Función que deja los valores iniciales que hemos definido y para el cronómetro
    currentTime = startPoint;
    counting = false;
  }

  void setPoints (int sPoint, int ePoint) { //Función que define el tiempo inicial y final
    startPoint = sPoint;
    endPoint = ePoint;

    if (startPoint <= endPoint) {
      up = true;
    } else {
      up = false;
    }

    currentTime = startPoint;
  }

  void update (int millis) { //Función que pasa los milisegundos que han pasado para actualizar el contador del cronómetro
    if (counting) {
      if (up) {
        currentTime += millis;
      } else {
        currentTime -= millis;
      }
    }
    if (getFinish()) {
      counting = false;
    }
  }

  void start (boolean onoff) { //Función para poner en marcha o parar el contador
    counting = onoff;
  }

  int getTimeMillis () {
    return currentTime;
  }

  float getTimeSec () {
    return (currentTime / 1000.0);
  }

  boolean getFinish() { //Función que nos indica si hemos llegado al final para poder controlar el estado del cronómetro
    if (up) {
      if (currentTime >= endPoint) {
        return true;
      } else {
        return false;
      }
    } else {
      if (currentTime <= endPoint) {
        return true;
      } else {
        return false;
      }
    }
  }
}
